---
title: WebGL2RenderingContext.texStorage2D()
slug: Web/API/WebGL2RenderingContext/texStorage2D
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.texStorage2D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API </a>specifies all levels of two-dimensional texture storage.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.texStorage2D(<var>target</var>, <var>levels</var>, <var>internalformat</var>, <var>width</var>, <var>height</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_2D</code>: A two-dimensional texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP</code>: A cube-mapped texture.</li>
 </ul>
 </dd>
 <dt><code>levels</code></dt>
 <dd>A {{domxref("GLint")}} specifying the number of texture levels.</dd>
 <dt><code>internalformat</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the texture store format. Possible values:
 <ul>
  <li><code>gl.R8</code></li>
  <li><code>gl.R16F</code></li>
  <li><code>gl.R32F</code></li>
  <li><code>gl.R8UI</code></li>
  <li><code>gl.RG8</code></li>
  <li><code>gl.RG16F</code></li>
  <li><code>gl.RG32F</code></li>
  <li><code>gl.RG8UI</code></li>
  <li><code>gl.RGB8</code></li>
  <li><code>gl.SRGB8</code></li>
  <li><code>gl.RGB565</code></li>
  <li><code>gl.R11F_G11F_B10F</code></li>
  <li><code>gl.RGB9_E5</code></li>
  <li><code>gl.RGB16F</code></li>
  <li><code>gl.RGB32F</code></li>
  <li><code>gl.RGB8UI</code></li>
  <li><code>gl.RGBA8</code></li>
  <li><code>gl.SRGB8_APLHA8</code></li>
  <li><code>gl.RGB5_A1</code></li>
  <li><code>gl.RGBA4</code></li>
  <li><code>gl.RGBA16F</code></li>
  <li><code>gl.RGBA32F</code></li>
  <li><code>gl.RGBA8UI</code></li>
 </ul>

 <p>Unlike OpenGL 3.0, WebGL 2 <strong>doesn't support</strong> the following ETC2 and EAC compressed texture formats (see <a href="https://www.khronos.org/registry/webgl/specs/latest/2.0/#5.37">section 5.37</a> in the WebGL 2 spec). You might be able to enable them via the {{domxref("WEBGL_compressed_texture_etc")}} extension, though.</p>

 <ul>
  <li><code>gl.COMPRESSED_R11_EAC</code></li>
  <li><code>gl.COMPRESSED_SIGNED_R11_EAC</code></li>
  <li><code>gl.COMPRESSED_RG11_EAC</code></li>
  <li><code>gl.COMPRESSED_SIGNED_RG11_EAC</code></li>
  <li><code>gl.COMPRESSED_RGB8_ETC2</code></li>
  <li><code>gl.COMPRESSED_RGBA8_ETC2_EAC</code></li>
  <li><code>gl.COMPRESSED_SRGB8_ETC2</code></li>
  <li><code>gl.COMPRESSED_SRGB8_ALPHA8_ETC2_EAC</code></li>
  <li><code>gl.COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></li>
  <li><code>gl.COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2</code></li>
 </ul>
 </dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the texture.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.texStorage2D(gl.TEXTURE_2D, 1, gl.RGB8, 256, 256);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.6", "texStorage2D")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glTexStorage2D.xhtml", "glTexStorage2D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.texStorage2D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGL2RenderingContext.texStorage3D()")}}</li>
 <li>{{domxref("WEBGL_compressed_texture_etc")}}</li>
</ul>
